;IBTINT		IR-BIT TRANSMITTER VIA TIMER2-OVERFLOW INT

IBTINT:		in	TSREG,SREG		;SREG->R9
		movw	r11:r10,XH:XL		;X-Pointer sichern
		movw	r13:r12,YH:YL		;Y-Pointer sichern
		movw	r15:r14,ZH:ZL		;Z-Pointer sichern

		lds	XL,BOC
		tst	XL
		brne	ibtint1
		cbi	DDRB,1			;BOC=0: Deinit IBTINT
		sts	TCCR2B,XL
		sts	TIMSK2,XL
		rjmp	sysint19

ibtint1:	cpi	XL,66
		brne	ibtint2
		cbi	DDRB,1			;BOC=66: Init 4,5ms Pause
		ldi	YL,126
		ldi	YH,6
		rjmp	ibtint9

ibtint2:	sbrs	XL,0
		rjmp	ibtint3
		sbi	DDRB,1			;BOC=ungerade: 
		ldi	YL,191			;0,56ms High-Bit
		ldi	YH,4
		rjmp	ibtint9

ibtint3:	cbi	DDRB,1			;BOC=gerade: 
		mov	XH,XL			;0,56/1,69ms Low(DataBit)
		lsr	XH			;XH= 8(BOC16) -> 1(BOC2)
		lds	YL,DADRL
		lds	YH,DADRH
		lds	ZL,TDCODE
		mov	ZH,ZL
		com	ZH
ibtint4:	rol	YL
		rol	YH
		rol	ZL
		rol	ZH
		dec	XH
		brne	ibtint4
		ldi	YL,61			;DATA HIGH-BIT
		brcs	ibtint5
		ldi	YL,191			;DATA LOW-BIT
ibtint5:	ldi	YH,4

ibtint9:	sts	TCCR2B,YH
		sts	TCNT2,YL
		dec	XL
		sts	BOC,XL
		rjmp	sysint19

;----------------------------------------------------------------------------------
;RXINT		RX BUFFER-INPUT (MIT CHECKSUMMEN-TEST)

RXINT:		in	TSREG,SREG		;SREG->R9
		movw	r11:r10,XH:XL		;X-Pointer sichern
		movw	r13:r12,YH:YL		;Y-Pointer sichern
		movw	r15:r14,ZH:ZL		;Z-Pointer sichern

		sbi	GPIOR0,RIP
		lds	XL,UCSR0A
		lds	XH,UDR0			;RECEIVER-DATABYTE
		andi	XL,$1c
		brne	rxint4			;RECEIVER ERROR OR
		lds	YL,COMRBPL
		cpi	YL,low(COMRBPL)
		breq	rxint4			;BUFFER OVERFLOW ERROR
		lds	XL,IRCC
		cpi	XL,12
		brlo	rxint4			;CURRENT IR-TRANSMISSION

		ldi	YH,1
		ldi	ZH,1
		cpi	YL,low(RBCSUM)
		brne	rxint3
		ld	XL,Y			;CHECKSUM TEST
		cp	XL,XH
		brne	rxint4			;CHECKSUM ERROR!
		ldi	XL,NCODE
		ori	XL,$80
		lds	XH,RCODE
		cp	XL,XH
		brne	rxint4			;NCODE ERROR!

		ldi	XL,14			;SUCCESSFUL RECEPTION:
		ldi	YL,low(RDATA1)
		ldi	ZL,low(DADRL)
rxint1:		ld	XH,Y+			;Daten-bernahme in
		st	Z+,XH			;Transmitter-Buffer
		dec	XL
		brne	rxint1
		sts	IRCC,XL			;START NEW CMD-QUEUE
		cbi	PORTC,0			;Red LED ON:
		sbi	PORTC,1			;Transmit IR-COMMAND(s)
		rjmp	sysint19

rxint3:		st	Y+,XH			;SAVE RECEIVER INPUT
		sts	COMRBPL,YL		;SAVE NEW COMRB-POINTER
		lds	XL,RBCSUM
		add	XL,XH
		sts	RBCSUM,XL		;CHECKSUM AKTUALISIEREN
		ldi	YL,RRTIME
		sts	HSEKTF1L,YL		;NEW INIT RESET TIMER
rxint4:		rjmp	sysint19

;----------------------------------------------------------------------------------
;TXINT		TX BUFFER-OUTPUT (MIT CHECKSUMMENBILDUNG)

TXINT:		in	TSREG,SREG		;SREG->R9
		movw	r11:r10,XH:XL		;X-Pointer sichern
		movw	r13:r12,YH:YL		;Y-Pointer sichern
		movw	r15:r14,ZH:ZL		;Z-Pointer sichern
		lds	YL,COMTBPL
		cpi	YL,low(COMTBPL)
		breq	txint1			;BUFFERENDE ERREICHT
		ldi	YH,1			;DATARAM-HIGH ADR
		ld	XH,Y+
		lds	XL,TBCSUM
		add	XL,XH
		sts	TBCSUM,XL
		sts	UDR0,XH			;OUTPUT (BUFFERADR)
		sts	COMTBPL,YL		;SAVE (NEXT BUFFERADR)
		rjmp	sysint19
txint1:		ldi	YL,$98			;DISABLE UDR0-EMPTY INT
		sts	UCSR0B,YL
		cbi	GPIOR0,TIP
		sbi	PORTC,0			;Green LED ON: Bereitschaft
		cbi	PORTC,1
		rjmp	sysint19

;----------------------------------------------------------------------------------
;SYSINT		SYSTEM-INTERRUPT (200Hz / 5 MSEK Cycle Time)

SYSINT:		in	TSREG,SREG		;SREG in R9 sichern
		movw	r11:r10,XH:XL		;X-Pointer sichern
		movw	r13:r12,YH:YL		;Y-Pointer sichern
		movw	r15:r14,ZH:ZL		;Z-Pointer sichern

		inc	SIC			;INC SYSINT-COUNTER
		sbrs	SIC,0
		rjmp	sysint3

		ldi	YL,3			;PROCESS HSEKTFx (100Hz)
		ldi	ZL,low(HSEKTF1L)
		ldi	ZH,high(HSEKTF1L)
sysint1:	ldd	XL,Z+0
		ldd	XH,Z+1
		sbiw	XH:XL,1
		brlo	sysint2
		std	Z+0,XL
		std	Z+1,XH
sysint2:	adiw	ZH:ZL,2
		dec	YL
		brne	sysint1

sysint3:	lds	XL,HSEKTF1L		;NO RECEIVERDATA(RRTIME):
		cpi	XL,1
		brne	sysint4
		clr	XL			;REINIT RECEIVER!
		sts	RBCSUM,XL
		ldi	XL,low(COMRBUF)
		sts	COMRBPL,XL
		cbi	GPIOR0,RIP

sysint4:	lds	XL,HSEKTF2L		;IR-CMD Control
		tst	XL		
		brne	sysint8			;CURRENT QUEUE PAUSE!
		lds	XL,IRCC
		cpi	XL,12
		brsh	sysint8			;NO CMD
		ldi	YL,low(CODE1)
		ldi	YH,1
		clr	XH
		add	YL,XL
		adc	YH,XH
		ld	XH,Y
		cpi	XH,VCMD
		breq	sysint5			;CMD VOID (FFH)
		sts	TDCODE,XH

		ldi	ZL,191			;Init IR-CMD
		sts	TCNT2,ZL
		ldi	ZL,1
		sts	TIMSK2,ZL
		ldi	ZL,66
		sts	BOC,ZL
		sbi	DDRB,1
		ldi	ZL,7
		sts	TCCR2B,ZL

		ldi	XH,CPTIME
		sts	HSEKTF2L,XH
sysint5:	inc	XL
		sts	IRCC,XL
		cpi	XL,12
		brne	sysint8

		ldi	XL,low(COMTBUF)		;Init Serial Transmitter
		sts	COMTBPL,XL
		ldi	XL,NCODE
		sts	TBCSUM,XL
		sts	UDR0,XL
		ldi	XL,$b8
		sts	UCSR0B,XL
		sbi	GPIOR0,TIP


sysint8:	mov	XL,SIC			;SYSTEM WORKING BLINK LED
		andi	XL,$07
		brne	sysint10
		sbis	PINC,0
		rjmp	sysint9
		cbi	PORTC,0
		rjmp	sysint10
sysint9:	sbi	PORTC,0

sysint10:

sysint19:	movw	ZH:ZL,r15:r14		;Z-Pointer wiederherstellen
		movw	YH:YL,r13:r12		;Y-Pointer wiederherstellen
		movw	XH:XL,r11:r10		;X-Pointer wiederherstellen
		out	SREG,TSREG		;SREG aus R9 wiederherstellen
RETURN:		reti

